#!/bin/sh

# finishing.mpkg
# MCPF 2st Install Method 4th part Script (extfinishing). Copyrights (c) @MLforAll. All rights reserved.

### funcs ###

defaultsWithSLcompatibility () {
	/tmp/rMCPF/hacking_datas/defaultsWithSLcompatibility.sh "$1" "$2" $3 "$4"
}

### Security ###

# Avoids launching the script! Useful for dev! A doubleclick can mess things up ;)

if [ ! -d /tmp/rMCPF/hacking_datas ]; then
	echo "MCPF Scripts Launch Security System"
	echo "Can't launch the script! Aborting!"
	exit 1
fi

### Start ###

echo "### start: extfinishing.sh ###"

### Remove PLatformSupport.plist ###

rm "$1/System/Library/CoreServices/PlatformSupport.plist"

### Copy BootLogo ###

#cp "/tmp/rMCPF/hacking_datas/BootLogo.png" "$1/System/Library/CoreServices" # Prefer using the orig Apple logo (Monitor issues and no simple way to detect the MacID of teh Mac you'll put the USB on.

cp "/tmp/rMCPF/hacking_datas/BootLogo_Monitor.png" "$1/System/Library/CoreServices/BLRec_Monitor.png"
cp "/tmp/rMCPF/hacking_datas/BootLogo.png" "$1/System/Library/CoreServices/BLRec.png"

### Replace boot.efi ###

if [ -f /tmp/ml.inst -o -f /tmp/mav.inst -o -f /tmp/yos.inst ]; then
	boot_efi_folder="ml_mav_yos"
else
	boot_efi_folder="ec_sierra"
fi

chflags nouchg "$1/System/Library/CoreServices/boot.efi"
cp "$1/System/Library/CoreServices/boot.efi" "$1/System/Library/CoreServices/boot64.efi"
cp /tmp/rMCPF/hacking_datas/boot_efi/$boot_efi_folder/boot32.efi "$1/System/Library/CoreServices"
rm "$1/System/Library/CoreServices/boot.efi"
if [ -f /tmp/64efi.mcpfoption ]; then
	cp "$1/System/Library/CoreServices/boot64.efi" "$1/System/Library/CoreServices/boot.efi"
else
	cp "$1/System/Library/CoreServices/boot32.efi" "$1/System/Library/CoreServices/boot.efi"
fi
rm "$1/usr/standalone/i386/boot.efi"
cp "$1/System/Library/CoreServices/boot.efi" "$1/usr/standalone/i386"
if [ -f "$1/System/Library/CoreServices/bootbase.efi" ]; then
	rm "$1/System/Library/CoreServices/bootbase.efi"
	cp "$1/System/Library/CoreServices/boot.efi" "$1/System/Library/CoreServices/bootbase.efi"
fi
chflags uchg "$1/System/Library/CoreServices/boot.efi"

### Change stuffs in com.apple.Boot.plist ###

if [ -f /tmp/yos.inst -o -f /tmp/ec.inst ]; then
	#defaults write "$1/Library/Preferences/SystemConfiguration/com.apple.Boot.plist" "Kernel Flags" -string "kext-dev-mode=1"
	defaultsWithSLcompatibility "$1/Library/Preferences/SystemConfiguration/com.apple.Boot.plist" "Kernel Flags" -string "kext-dev-mode=1"
fi

if [ -f /tmp/ec.inst ]; then
	kcache="$1/System/Library/PrelinkedKernels/prelinkedkernel"
	kcacheUEFIpath="\System\Library\PrelinkedKernels\prelinkedkernel"
else
	kcache="$1/System/Library/Caches/com.apple.kext.caches/Startup/kernelcache"
	kcacheUEFIpath="\System\Library\Caches\com.apple.kext.caches\Startup\kernelcache"
fi

if [ -f "$kcache" ]; then
	minimumKCsize=8388608
	actualKCsize=$(stat -f %z "$kcache")

	if [ $actualsize -ge $minimumKCsize ]
	then
		defaultsWithSLcompatibility "$1/Library/Preferences/SystemConfiguration/com.apple.Boot.plist" "Kernel Cache" -string "$kcacheUEFIpath"
	fi
fi

### Hide some stuffs ###

file_list=(rec
	Hack
	*.inst
	*.mcpf
	*.mcpfoption
);

for file in "${file_list[@]}"; do
	nbFile=$(find "$1"/* -name "$file" ''-maxdepth 1'' | wc -l)
	if (( $nbFile >= 1 )); then chflags -h hidden "$1"/$file ; fi
done

### Name the volume ###

while read line ; do name=$line ; done < /tmp/instTo.mcpf
bless --folder "$1/System/Library/CoreServices" -label "$name (MCPF)"

### Unmount volumes ###

hdiutil detach /Volumes/BSE || true
hdiutil detach /Volumes/mcpfESD || true

### Remove temp files ###

rm -f /tmp/*.inst

### End ###

echo "### end: extfinishing.sh ###"
exit 0
