#!/bin/sh

# system.mpkg
# MCPF 2st Install Method 2nd part Script (extsystem). Copyrights (c) @MLforAll. All rights reserved.

### funcs ###

defaultsWithSLcompatibility () {
	/tmp/rMCPF/hacking_datas/defaultsWithSLcompatibility.sh "$1" "$2" $3 "$4"
}

### Security ###

# Avoids launching the script! Useful for dev! A doubleclick can mess things up ;)

if [ ! -d /tmp/rMCPF/hacking_datas ]; then
	echo "MCPF Scripts Launch Security System"
	echo "Can't launch the script! Aborting!"
	exit 1
fi

### Start ###

echo "### start: extsystem.sh ###"

### Vars ###

instFiles=()
instFilesForCount=0
for f in /tmp/*.inst
do
instFiles[$instFilesForCount]="$f"
instFilesForCount+=1
done
if [ ${#instFiles[@]} -eq 0 ]; then exit 1 ; fi
instFile=${instFiles[0]}
osxinstNoPrefix=${instFile#/tmp/}
osxinst=${osxinstNoPrefix%.inst}
touch "$1/$osxinst.inst"

### Copy AppleScript frameworks ###

cp -R /tmp/rMCPF/hacking_datas/rec/ASinstall/* "$1/System/Library"

### Copy Apple/MCPF OS X Installer ###

if [ -f /tmp/yos.inst -o -f /tmp/ec.inst ]; then

	if [ -f /tmp/yos.inst ]; then
		diskmanagementdPath="$1/usr/sbin/diskmanagementd"
	else
		diskmanagementdPath="$1/usr/libexec/diskmanagementd"
	fi

	cp -R /tmp/rMCPF/hacking_datas/rec/NewInstall/OSInstall.framework "$1/System/Library/PrivateFrameworks/Install.framework/Frameworks"
	ln -s ../../Frameworks "$1/System/Library/PrivateFrameworks/Install.framework/Versions/A"

	rm -R "$1/System/Library/PrivateFrameworks/SystemMigration.framework"
	cp -R /tmp/rMCPF/hacking_datas/rec/NewInstall/SystemMigration.framework "$1/System/Library/PrivateFrameworks"
	
	rm "$1/usr/sbin/installer"
	cp /tmp/rMCPF/hacking_datas/rec/NewInstall/installer "$1/usr/sbin"

	if [ -f /tmp/yos.inst ]; then
		rm -R "$1/System/Library/PrivateFrameworks/DiskManagement.framework"
		cp -R /tmp/rMCPF/hacking_datas/rec/NewInstall/dmtest_needs/DiskManagement.framework "$1/System/Library/PrivateFrameworks"
		rm "$diskmanagementdPath"
		cp /tmp/rMCPF/hacking_datas/rec/NewInstall/dmtest_needs/diskmanagementd "$diskmanagementdPath"
	fi

	cp -R /tmp/rMCPF/hacking_datas/rec/NewInstall/AppleShareClientCore.framework "$1/System/Library/Frameworks"

	if [ -f /tmp/ec.inst ]; then
		rm -R "$1/System/Library/PrivateFrameworks/PackageKit.framework"
		cp -R /tmp/rMCPF/hacking_datas/rec/NewInstall/EC/PackageKit.framework "$1/System/Library/PrivateFrameworks"
	fi
fi

if [ ! -f /tmp/useAppleInstaller.mcpfoption ]; then
	
	mv "$1/System/Installation/CDIS/OS X Installer.app" "$1/System/Installation/CDIS/Apple OS X Installer.app"
	mv "$1/System/Installation/CDIS/Apple OS X Installer.app/Contents/MacOS/OS X Installer" "$1/System/Installation/CDIS/Apple OS X Installer.app/Contents/MacOS/Apple OS X Installer"
	defaultsWithSLcompatibility "$1/System/Installation/CDIS/Apple OS X Installer.app/Contents/Info.plist" CFBundleExecutable -string "Apple OS X Installer"
	chmod 755 "$1/System/Installation/CDIS/Apple OS X Installer.app/Contents/Info.plist"
	rm "$1/System/Installation/CDIS/Apple OS X Installer.app/Contents/Resources/InstallerMenuAdditions.plist"

	cp -R /tmp/rMCPF/hacking_datas/rec/NewInstall/ExpInstaller.app "$1/System/Installation/CDIS/OS X Installer.app"
	mv "$1/System/Installation/CDIS/OS X Installer.app/Contents/MacOS/ExpInstaller" "$1/System/Installation/CDIS/OS X Installer.app/Contents/MacOS/OS X Installer"
	defaultsWithSLcompatibility "$1/System/Installation/CDIS/OS X Installer.app/Contents/Info.plist" CFBundleExecutable -string "OS X Installer"
	chmod 755 "$1/System/Installation/CDIS/OS X Installer.app/Contents/Info.plist"

fi

### Prevent display/cpu sleep ###

if [ -f "$1/Library/Preferences/SystemConfiguration/com.apple.PowerManagement.plist" ]; then
	rm "$1/Library/Preferences/SystemConfiguration/com.apple.PowerManagement.plist"
fi
cp /tmp/rMCPF/hacking_datas/rec/com.apple.PowerManagement.plist "$1/Library/Preferences/SystemConfiguration"

### Copy Boot File Changer.app ###

cp -R "/tmp/rMCPF/hacking_datas/Boot File Changer.app" "$1/"

### Copy MCPF Hacked/Resources files ###

mkdir "$1/rec"
cp -R /tmp/rMCPF/hacking_datas/rec/* "$1/rec/"
cp /tmp/mcpfESD/BaseSystem.dmg "$1/rec"
cp /tmp/mcpfESD/BaseSystem.chunklist "$1/rec"
chflags nohidden "$1/rec/BaseSystem"*

mkdir "$1/Hack"
cp -R /tmp/rMCPF/hacking_datas/HackFolder "$1/Hack"

sh /tmp/rMCPF/hacking_datas/createInstalledVersionPlist.sh "$1/Hack/Features/MCPF"
sh /tmp/rMCPF/hacking_datas/rec/unzipPatchesAndInstallKextsHackFolder.sh "Hack" "$osxinst" "/tmp/rMCPF/hacking_datas/rec" "/tmp" "$1"

rm -R "$1/System/Library/Caches/com.apple.kext.caches"
chmod -R 755 "$1/System/Library/Extensions"
chown -R root:wheel "$1/System/Library/Extensions"
touch "$1/System/Library/Extensions"
kextcache -f -update-volume "$1/"

### Creating new prelinkedkernel/kernelcache ###

if [ -f /tmp/ml.inst -o -f /tmp/mav.inst ]; then kern="$1/mach_kernel" ; else kern="$1/System/Library/Kernels/kernel" ; fi
if [ -f "$1/System/Library/PrelinkedKernel/prelinkedkernel" ]; then kerncache="$1/System/Library/PrelinkedKernels/prelinkedkernel" ; else kerncache="$1/System/Library/Caches/com.apple.kext.caches/Startup/kernelcache" ; fi
rm "$kerncache"
kextcache -prelinked-kernel "$kerncache" -z -K "$kern" -volume-root "$1" "$1/System/Library/Extensions"

### Moving some empty res files ###

if [ -f /tmp/smallRecovery.mcpfoption ]; then mv /tmp/smallRecovery.mcpfoption "$1/" ; fi

### End ###

echo "### end: extsystem.sh ###"
exit 0
