#!/bin/bash

# MCPF Hacking Process Script. Copyrights (c) @MLforAll. All rights reserved.
# Install Script v2.4
# Last revision 25/09/16

### Output ###

echo ""
echo "Script: Process"
echo ""

### Get basedir ###

if [ -f "$(pwd)/$(basename $0)" ]; then
	sdir=$(pwd)
else
	sdir=$(dirname "$0")
fi

### Get if OS X Verion is ML, Mav or Yos

ver=$(defaults read "$1/System/Library/CoreServices/SystemVersion.plist" ProductVersion)

case "$ver" in
10.8*)
	osxinst="ml"
	;;
10.9*)
	osxinst="mav"
	;;
10.10*)
	osxinst="yos"
	;;
esac

### Script ###

hackFolderName="Hack"

if [ ! -d "$1/Hack" ] && [ -f /tmp/32migration.mcpfoption ]; then
	echo "==> Migration: Hack folder not there, using Hack_creating!"
	#ln -s "$1/Hack_creating" "$1/Hack"
	hackFolderName="Hack_creating"
	echo "==> Migration: Replacing SystemVersion.plist"
	version=$(defaults read "$1/System/Library/CoreServices/SystemVersion.plist" ProductVersion)
	rm "$1/System/Library/CoreServices/SystemVersion.plist"
	cp "/tmp/rMCPF/hacking_datas/migrationSVplists/$version.plist" "$1/System/Library/CoreServices/SystemVersion.plist"
fi

rm "$1/System/Library/CoreServices/PlatformSupport.plist"

if [ -f "$1/$hackFolderName/32install.mcpfoption" ]; then
	echo "==> HackInstall32: Launching..."
	"$sdir/32install/install.sh" "$1"
else

	echo "==> HackInstall: Launching..."

	echo "==> HackInstall: Replacing boot.efi"
	chflags nouchg "$1/System/Library/CoreServices/boot.efi"
	rm "$1/System/Library/CoreServices/boot.efi"
	cp "$1/System/Library/CoreServices/boot_s.efi" "$1/System/Library/CoreServices/boot.efi"
	chflags uchg "$1/System/Library/CoreServices/boot.efi"
	
	echo "==> HackInstall: Replacing AppleHDA.kext"
	rm -R "$1/System/Library/Extensions/AppleHDA.kext"
	cp -R "$sdir/AppleHDA.kext" "$1/System/Library/Extensions"
	if [ "$osxinst" != "ml" ] && [ "$osxinst" != "mav" ] && [ "$osxinst" == "yos" ]; then
		echo "==> HackInstall: Installing USBHostBTPatch (El Capitan+)"
		"$sdir/USBHostBTPatch/install.sh" "$1"
	fi

fi

if [ ! -f /tmp/lupdate.mcpfoption ]; then
	"$sdir/Graphics/install.sh" "$1"
fi

echo "==> InstallEnd: Updating kextcache..."
chmod -R 755 "$1/System/Library/Extensions"
chown -R root:wheel "$1/System/Library/Extensions"
touch "$1/System/Library/Extensions"
kextcache -f -update-volume "$1"

echo "==> InstallEnd: Cleaning..."
chflags hidden "$1/System/Library/CoreServices/uuid.mcpf"

echo "==> Hack successfully installed!"

### End ###

echo ""
echo "-------------"
echo ""

exit 0
