#!/bin/sh

# extract.mpkg
# MCPF 1st Install Method 1st part Script. Copyrights (c) @MLforAll. All rights reserved.
# 2016

### Security ###

# Avoids launching the script! Useful for dev! A doubleclick can mess things up ;)

if [ ! -d /tmp/rMCPF/hacking_datas ]; then
	echo "MCPF Scripts Launch Security System"
	echo "Can't launch the script! Aborting!"
	exit 1
fi

### Start ###

echo "### start: compcreate.sh ###"

### Script ###

if [ -f "$1/BS.dmg" ]; then rm "$1/BS.dmg" ; fi

useOldMethod="no"
if [ -f /tmp/smallRecovery.mcpfoption ]; then
	useOldMethod="yes"
else
	if [ -f /tmp/ml.inst ]; then
		recMB=5500
	elif [ -f /tmp/ec.inst -o /tmp/sierra.inst ]; then
		recMB=7500
	else
		recMB=6500
	fi
fi

if [ "$useOldMethod" == "yes" ]; then

	echo "Creating Small Recovery"

	if [ ! -d /Volumes/mcpfESD ]; then
		echo "ERR: Can't find the mcpfESD volume... The installation cannot continue!"
		exit 1
	fi

	hdiutil convert -format UDRW -o "$1/BS.dmg" /tmp/mcpfESD/BaseSystem.dmg || echo "Failed to convert the BS diskimage"
	hdiutil resize -size 1653m "$1/BS.dmg" || echo "Failed to resize the diskimage"

	if [ ! -f "$1/BS.dmg" ]; then
		echo "ERR: Cannot find BS.dmg!"
		exit 1
	fi

	mkdir /Volumes/BS || echo "Failed to create the diskimage mountpoint folder"
	hdiutil attach -noverify -mountpoint /Volumes/BS "$1/BS.dmg" -nobrowse || echo "Failed to mount the diskimage"

else

	echo "Creating Normal Recovery"

	hdiutil create -megabytes $recMB -fs HFS+ -volname "MCPF Recovery" "$1/BS.dmg" || "Failed to create an empty diskimage"
	mkdir /Volumes/BS || echo "Failed to create the diskimage mountpoint folder"
	hdiutil attach -noverify -mountpoint /Volumes/BS "$1/BS.dmg" -nobrowse || echo "Failed to mount the diskimage"
	mkdir /Volumes/BSorig || echo "Failed to create the orig diskimage mountpoint folder"
	hdiutil attach -noverify -mountpoint /Volumes/BSorig /tmp/mcpfESD/BaseSystem.dmg -nobrowse  || echo "Failed to mount the orig diskimage"
	
	diskutil enableOwnership /Volumes/BS || echo "Failed to enable ownership on the diskimage's volume"
	cp -R -p /Volumes/BSorig/* /Volumes/BS  || echo "Coulnd't copy all the OS X installation system files"
	
	hdiutil detach /Volumes/BSorig || echo "Failed to unmount the orig diskimage"

fi

### End ###

echo "### end: compcreate.sh ###"
exit 0
