#!/bin/sh

# finishing.mpkg
# MCPF 1st Install Method 4th part Script (compfinishing). Copyrights (c) @MLforAll. All rights reserved.
# 2016

### funcs ###

defaultsWithSLcompatibility () {
	/tmp/rMCPF/hacking_datas/defaultsWithSLcompatibility.sh "$1" "$2" $3 "$4"
}

### Security ###

# Avoids launching the script! Useful for dev! A doubleclick can mess things up ;)

if [ ! -d /tmp/rMCPF/hacking_datas ]; then
	echo "MCPF Scripts Launch Security System"
	echo "Can't launch the script! Aborting!"
	exit 1
fi

### Start ###

echo "### start: compfinishing.sh ###"

### Copy .mcpfoption files if needed ###

if [ -f /tmp/updSys.mcpfoption ]; then
	cp /tmp/updSys.mcpfoption "$1/.IABootFiles"
	rm /tmp/updSys.mcpfoption
fi

if [ -f /tmp/CLSys.mcpfoption ]; then
	cp /tmp/CLSys.mcpfoption "$1/.IABootFiles"
	rm /tmp/CLSys.mcpfoption
fi

### Copy required TemRec resources ###

cp /tmp/rMCPF/hacking_datas/rec/*mountRec.scpt "$1/.IABootFiles"
cp /tmp/rMCPF/hacking_datas/rec/createRecHD.sh "$1/.IABootFiles"
cp /tmp/rMCPF/hacking_datas/rec/dmtest "$1/.IABootFiles"
diskutil info -plist / > "$1/.IABootFiles/runVolumeInfo.mcpf.plist"

if [ -f /tmp/ocInst.mcpfoption ]; then cp /tmp/ocInst.mcpfoption "$1/.IABootFiles" ; fi
if [ -f /tmp/avoidOCintErrs.mcpfoption ]; then cp /tmp/avoidOCintErrs.mcpfoption "$1/.IABootFiles" ; fi

### Init blessRec ###

blessRec="no"

### Add the kernelcache ###

#if [ -f /tmp/kernelcache ]; then
#	cp -p /tmp/kernelcache "$1/.IABootFiles"
#	rm /tmp/kernelcache
#else
#	echo "kernelcache not found in /tmp/. The TempRec may have issues to boot."
#fi

mv /tmp/origKernelCache "$1/.IABootFiles/kernelcache"

mlKernelPath="/tmp/mcpfESD/mach_kernel"
otherKernelPath="/tmp/osxkern"
if [ -f /tmp/ml.inst ]; then kern="$mlKernelPath" ; else kern="$otherKernelPath" ; fi
cp "$kern" "$1/.IABootFiles/osxkern"


### Add com.apple.Boot.plist ###

cp /tmp/rMCPF/hacking_datas/rec/com.apple.Boot.plist "$1/.IABootFiles"

if [ -f /tmp/yos.inst ]; then
	kflags="rp=file:///.IABootFiles/BS.dmg kext-dev-mode=1"
else
	kflags="rp=file:///.IABootFiles/BS.dmg"
fi

#defaults write "$1/.IABootFiles/com.apple.Boot.plist" "Kernel Flags" -string "$kflags"
#defaults write "$1/.IABootFiles/com.apple.Boot.plist" "Boot Logo" -string "\.IABootFiles\BootLogo.png"
#defaults write "$1/.IABootFiles/com.apple.Boot.plist" "Kernel Cache" -string "\.IABootFiles\kernelcache"

#if [ -f "$1/.IABootFiles/com.apple.Boot.plist.plist" ]; then # SL compatibility
#	defaults write "$1/.IABootFiles/com.apple.Boot.plist" "Background Color" -int "16711679"
#	rm "$1/.IABootFiles/com.apple.Boot.plist"
#	mv "$1/.IABootFiles/com.apple.Boot.plist.plist" "$1/.IABootFiles/com.apple.Boot.plist"
#fi

#plutil -convert xml1 "$1/.IABootFiles/com.apple.Boot.plist"

defaultsWithSLcompatibility "$1/.IABootFiles/com.apple.Boot.plist" "Kernel Flags" -string "$kflags"
defaultsWithSLcompatibility "$1/.IABootFiles/com.apple.Boot.plist" "Boot Logo" -string "\.IABootFiles\BootLogo.png"
defaultsWithSLcompatibility "$1/.IABootFiles/com.apple.Boot.plist" "Kernel Cache" -string "\.IABootFiles\kernelcache"

### Copy BootLogo ###

model=$(sysctl hw.model)

if [ "$model" == "hw.model: Macmini1,1" -o "$model" == "hw.model: Macmini2,1" -o "$model" == "hw.model: MacPro1,1" -o "$model" == "hw.model: MacPro2,1" ]; then
	cp "/tmp/rMCPF/hacking_datas/BootLogo_Monitor.png" "$1/.IABootFiles/BootLogo.png"
else
	cp "/tmp/rMCPF/hacking_datas/BootLogo.png" "$1/.IABootFiles"
fi

### Add boot.efi ###

if [ -f /tmp/ml.inst -o -f /tmp/mav.inst -o -f /tmp/yos.inst ]; then
	boot_efi_folder="ml_mav_yos"
else
	boot_efi_folder="ec_sierra"
fi

if [ -f /tmp/64efi.mcpfoption ]; then
	cp /tmp/rMCPF/hacking_datas/boot_efi/$boot_efi_folder/boot64.efi "$1/.IABootFiles/boot.efi"
else
	cp /tmp/rMCPF/hacking_datas/boot_efi/$boot_efi_folder/boot32.efi "$1/.IABootFiles/boot.efi"
fi

### Bless the temp MCPF Rec System ###

while read line ; do volName=$line ; done < /tmp/instTo.mcpf
bless --folder "$1/.IABootFiles" -label "Create Recovery on $volName"
blessRec="yes"

if [ -f /tmp/lupdate.mcpfoption ]; then
	touch /tmp/test.mcpf
	if [ -f "$1/tmp/test.mcpf" ] && [ ! -f /tmp/migration.mcpfoption ]; then
		touch "$1/.IABootFiles/lupdate.mcpfoption"
		if [ -f /tmp/32migration.mcpfoption ]; then
			touch "$1/.IABootFiles/32migration.mcpfoption"
		fi
		blessRec="yes"
	fi
	rm /tmp/test.mcpf
fi

if [ -f /tmp/migration.mcpfoption ]; then
	touch "$1/.IABootFiles/updSys.mcpfoption"
	blessRec="yes"
fi

### Replacing boot.efi if /tmp/update.mcpfoption or /tmp/lupdate.mcpfoption exist ###

if [ -f "$1/System/Library/CoreServices/boot_s.efi" ]; then

	if [ -f /tmp/update.mcpfoption -o -f /tmp/lupdate.mcpfoption ]; then

		model=$(sysctl hw.model)

		if [ "$model" == "hw.model: MacBook3,1" ]; then
			bootEFIfile="boot64.efi"
		elif [ "$model" == "hw.model: MacBook4,1" ]; then
			bootEFIfile="boot64.efi"
		else
			bootEFIfile="boot32.efi"
		fi

		rm "$1/System/Library/CoreServices/boot_s.efi"
		cp "/tmp/rMCPF/hacking_datas/boot_efi/$boot_efi_folder/$bootEFIfile" "$1/System/Library/CoreServices/boot_s.efi"
		if [ -f /tmp/update.mcpfoption ]; then
			chflags nouchg "$1/System/Library/CoreServices/boot.efi"
			rm "$1/System/Library/CoreServices/boot.efi"
			cp "$1/System/Library/CoreServices/boot_s.efi" "$1/System/Library/CoreServices/boot.efi"
			chflags uchg "$1/System/Library/CoreServices/boot.efi"
		fi
	fi

fi

### Replacing MCPF Apps ####

if [ -d "$1/Applications/MacPostFactor Utilities.app" ]; then
	rm -R "$1/Applications/MacPostFactor Utilities.app"
	mkdir "$1/Hack_creating/Features/MCPF_Utils_extract"
	unzip /tmp/rMCPF/hacking_datas/HackFolder/Features/MCPF_Utils.zip -d "$1/Hack_creating/Features/MCPF_Utils_extract"
	cp -R "$1/Hack_creating/Features/MCPF_Utils_extract/MacPostFactor Utilities.app" "$1/Applications"
	rm -R "$1/Hack_creating/Features/MCPF_Utils_extract"
fi

### Finishing Hack folder ###

if [ -d "$1/Hack" ]; then
	rm "$1/Hack_creating/Features/versionnot.plist"
	cp "$1/Hack/Features/versionnot.plist" "$1/Hack_creating/Features/versionnot.plist"
	rm -R "$1/Hack"
fi
mv "$1/Hack_creating" "$1/Hack"

### MCPF Large Update ###

if [ -f /tmp/lupdate.mcpfoption ]; then
	
	if [ -f "$1/mach_kernel" ]; then kernPath="$1/mach_kernel" ; elif [ -f "$1/System/Library/Kernels/kernel" ]; then kernPath="$1/System/Library/Kernels/kernel" ; fi
	cp "$kernPath" /tmp/osxkern_bkp

	/tmp/rMCPF/hacking_datas/MCPFUpdate.sh "$1/"
	/tmp/rMCPF/hacking_datas/HackFolder/Patches/Process.sh "$1/"

	#touch /tmp/test.mcpf
	#if [ ! -f "$1/tmp/test.mcpf" ]; then /tmp/rMCPF/hacking_datas/Patches/Graphics.sh "$1" ; fi
	#rm /tmp/test.mcpf
	/tmp/rMCPF/hacking_datas/HackFolder/Patches/Graphics.sh "$1"

	if [ ! -f "$kernPath" ]; then cp /tmp/osxkern_bkp "$kernPath" ; fi
	rm /tmp/osxkern_bkp
fi

### Blessing or not blessing (that is the question ;)) ###

if [ "$blessRec" == "yes" ]; then
	bless --folder "$1/.IABootFiles" --file "$1/.IABootFiles/boot.efi" --setBoot
fi

### Erasing some temp files ###

if [ -f /tmp/ml.inst ]; then
	rm /tmp/ml.inst
elif [ -f /tmp/mav.inst ]; then
	rm /tmp/mav.inst
elif [ -f /tmp/yos.inst ]; then
	rm /tmp/yos.inst
elif [ -f /tmp/ec.inst ]; then
	rm /tmp/ec.inst
fi

### End ###

echo "### end: compfinishing.sh ###"
exit 0
