#!/bin/sh

# MCPF createInstalledVersionPlist.sh Script. Copyrights (c) @MLforAll. All rights reserved.
# Install Script v1.0
# Last revision 26/07/16

tmpPlistPath=/tmp/tmpInstalledVersion.plist
exitState=0

echo "===> createInstalledVersionPlist.sh Output <==="

if [ ! -d /tmp/rMCPF ]; then
	echo "MacPostFactor doesn't seem to be openned!"
	echo "Cannot continue!"
	echo "Exiting..."
	exitState=1
fi

# --

if [ "$exitState" == 0 ]; then

	# Create plist file based on sample

	echo "<?xml version="1.0" encoding="UTF-8"?>
	<!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
	<plist version="1.0">
	<dict>
		<key>iversion</key>
		<string>decimalVersion</string>
		<key>verStr</key>
		<string>stringVersion</string>
	</dict>
	</plist>
	" > $tmpPlistPath

	# gather key values

	decimalVersion=$(defaults read /tmp/rMCPF/version.plist MCPFver)
	stringVersion=$(defaults read /tmp/rMCPF/../Info.plist CFBundleShortVersionString)

	# set key values

	defaults write $tmpPlistPath iversion $decimalVersion
	defaults write $tmpPlistPath verStr $stringVersion

	# copy file to folder path provided by 1st param ($1) if it exists

	if [ -d "$1" ]; then
		mv $tmpPlistPath "$1/InstalledVersion.plist"
	else
		echo "Suplied path doesn't exist!"
		echo "Cannot continue!"
		echo "Exiting..."
		exitState=1
	fi

fi

# --

echo "========================================"

exit $exitState
