#!/bin/sh

# defaultsWithSLcompatibility.sh
# By MLforAll, 2016

# Why?
# On Snow Leopard, the defaults command doesn't work the same way as in Lion+
# In order to make MCPF compatible with Snow Leopard without any hicups, I had
# to create this shell script that uses some tricks to get the same result for
# both SL's defaults cmd and Lion+'s one

# Launched command : defaults write input_file input_key input_type input_value

### Check if running SL ###

compatibilityMode="no"
ver=$(defaults read /System/Library/CoreServices/SystemVersion.plist ProductVersion)

case "$ver" in
10.6*)
	compatibilityMode="yes"
	;;
esac

### Defaults Stuffs ###

editedFile="$1"
if [ "$compatibilityMode" == "yes" ]; then
	cp "$1" "$1.plist"
	editedFile="$1.plist"
fi
defaults write "$1" "$2" $3 "$4"
plutil -convert xml1 "$editedFile"
chmod 755 "$editedFile"
if [ "$compatibilityMode" == "yes" ]; then
	rm "$1"
	mv "$1.plist" "$1"
fi
