#!/bin/sh

# generateMacSystemInfos.sh
# MLforAll
# 2016

### Get tis scpt folder ###

if [ -f "$(pwd)/$(basename $0)" ]; then
	sdir=$(pwd)
else
	sdir=$(dirname "$0")
fi

### Gather infos ###

outFile="/tmp/macSystemInfosRport.mcpf"
if [ "$1" != "" ]; then outFile="$1" ; fi
echo "-> Ouput file is : $outFile"

echo "-> Gathering infos"

osxVer=$(defaults read /System/Library/CoreServices/SystemVersion.plist ProductVersion)
macModelID=$(ioreg -l | awk '/product-name/ { split($0, line, "\""); printf("%s\n", line[4]); }')

diskutil info -plist / > /tmp/getBootVolumeInfos.mcpf.plist
bootVolumeName=$(defaults read /tmp/getBootVolumeInfos.mcpf.plist VolumeName)
rm /tmp/getBootVolumeInfos.mcpf.plist

mcpfVer="Unknown"
if [ -d /tmp/rMCPF ]; then
	mcpfVer=$(defaults read /tmp/rMCPF/../Info.plist CFBundleShortVersionString) || mcpfVer=$(defaults read /tmp/rMCPF/version.plist MCPFver)
else
	echo "   MacPostFactor doesn't seem to be opened!"
fi

if [ -f "$outFile" ]; then
	echo "   Removing old copy of the output file ($outFile)"
	rm "$outFile"
fi

errCodeNo=$("$sdir/getErrCodeNo.sh")

### Writing infos to file ###

echo "-> Writing those to $outFile"

echo "### MCPF DEBUG INFOS ###
### THIS FILE IS AUTO GENERATED BY MCPF ###

-> Mac Model ID : $macModelID

-> OS X Version : $osxVer
-> Boot Volume Name : $bootVolumeName

-> MacPostFactor Version : $mcpfVer
-> Error Code Number : $errCodeNo

### END OF THE REPORT ###" > "$outFile"

### End ###

echo "-> Done!"
