#!/bin/sh

# modify.sh
# MCPF 1st Install Method 2nd part Script. Copyrights (c) @MLforAll. All rights reserved.

### funcs ###

defaultsWithSLcompatibility () {
	sh /tmp/rMCPF/hacking_datas/defaultsWithSLcompatibility.sh "$1" "$2" $3 "$4"
}

###### Installed || Installer (USB)? ######

if [ -d /System/Installation ]; then
	tmpFileDir="/"
	bigTmpStorage="${3}"
	smallTmpStorage="/Volumes/MCPF_Tmp_RD"
	recDir="/rec"
	hackCreating="Hack"
	sys="installation"
else
	tmpFileDir="/tmp"
	bigTmpStorage=$tmpFileDir
	smallTmpStorage=$tmpFileDir
	recDir="/tmp/rMCPF/hacking_datas/rec"
	hackCreating="Hack_creating"
	sys="installed"
fi
downloadsFolderPath=~/Library/MCPF/Downloads # only available when sys == installed

### GMA-equipped Mac ? ###

model=$(sysctl hw.model)

if [ "$model" == "hw.model: MacBook2,1" -o "$model" == "hw.model: MacBook3,1" -o "$model" == "hw.model: MacBook4,1" -o "$model" == "hw.model: iMac4,2" -o "$model" == "hw.model: iMac5,2" -o "$model" == "hw.model: Macmini1,1" -o "$model" == "hw.model: Macmini2,1" ]; then
	isGMA="yes"
else
	isGMA="no"
fi

###### Which OS version are we currently patching the RecHD? ######

instFiles=()
instFilesForCount=0
for f in /tmp/*.inst
do
	instFiles[$instFilesForCount]="$f"
	instFilesForCount+=1
done
if [ ${#instFiles[@]} -eq 0 ]; then exit 1 ; fi
instFile=${instFiles[0]}
osxinstNoPrefix=${instFile#/tmp/}
osxinst=${osxinstNoPrefix%.inst}
touch /Volumes/BS/$osxinst.inst

###### OS X or macOS ? ######

if [ -f /tmp/ml.inst -o -f /tmp/mav.inst -o -f /tmp/yos.inst -o -f /tmp/ec.inst ]; then
	osName="OS X"
else
	osName="macOS"
fi

###### Managing Packages ######

rm -v "/Volumes/BS/System/Installation/Packages"
installPkgs="yes"
if [ -f $tmpFileDir/smallRecovery.mcpfoption ]; then
	cp -v $tmpFileDir/smallRecovery.mcpfoption "/Volumes/BS"
	if [ -f /tmp/update.mcpfoption -o -f /tmp/lupdate.mcpfoption -o -f /tmp/32migration.mcpfoption -o -f /tmp/CLSys.mcpfoption -o "$sys" == "installation" ]; then
		installPkgs="no"
	fi
	packagesPath="$1/System/Library/Packages"
	ln -s "/volD/System/Library/Packages" "/Volumes/BS/System/Installation/Packages"
else
	packagesPath="/Volumes/BS/Packages"
	ln -s "/Packages" "/Volumes/BS/System/Installation/Packages"
fi

if [ "$sys" == "installed" ]; then
	if [ ! -d "$1/System" ]; then
		mkdir "$1/System"
		mkdir "$1/System/Library"
		mkdir "$1/System/Library/CoreServices"
	fi
fi

if [ "$installPkgs" == "yes" ]; then
	if [ ! -d "$packagesPath" ]; then

		cp -rv "/tmp/mcpfESD/Packages" "$packagesPath"
		
		rm -v "$packagesPath/OSInstall.mpkg"
		rm -v "$packagesPath/OSInstall.pkg"
		
		if [ "$sys" == "installed" ]; then
			OSInstallPkgPath="/tmp/rMCPF/hacking_datas/InstallationFiles/OSInstall.pkg"
		else
			OSInstallPkgPath="/System/Installation/Packages/OSInstall.pkg"
		fi

		cp -v "$OSInstallPkgPath" "$packagesPath"

	fi

	if [ -d "$1/System/Library/Packages" ] && [ "$packagesPath" == "/Volumes/BS/Packages" ]; then
		rm -rv "$1/System/Library/Packages"
	fi
fi

cp -v $recDir/OSInstall_$osxinst.mpkg "/Volumes/BS/System/Installation/OSInstall.mpkg"

if [ "$sys" == "installed" ]; then

	mkdir "$1/Hack_creating"
	chflags hidden "$1/Hack_creating"
	cp -rv $tmpFileDir/rMCPF/hacking_datas/HackFolder/* "$1/Hack_creating"

	sh $tmpFileDir/rMCPF/hacking_datas/createInstalledVersionPlist.sh "$1/Hack_creating/Features"

fi

ln -s /volD/Hack "/Volumes/BS/Hack"

###### Managing dest volume access ######

ln -s "/Volumes/Image Volume/mcpftmp/volD" "/Volumes/BS/volD"
ln -s "/Volumes/Image Volume/" "/Volumes/BS/swap"

diskutil info -plist "$1" > $smallTmpStorage/pid2.mcpf.plist
defaults read $smallTmpStorage/pid2.mcpf.plist VolumeUUID > "$1/System/Library/CoreServices/uuid.mcpf"
chflags hidden "$1/System/Library/CoreServices/uuid.mcpf"
rm -v $smallTmpStorage/pid2.mcpf.plist

###### Managing Important Files ######

cp -v $recDir/unmountVols.sh "/Volumes/BS/System/Installation/CDIS"

if [ -f "/Volumes/BS/Library/Preferences/SystemConfiguration/com.apple.PowerManagement.plist" ]; then
	rm -v "/Volumes/BS/Library/Preferences/SystemConfiguration/com.apple.PowerManagement.plist"
fi
cp -v $recDir/com.apple.PowerManagement.plist "/Volumes/BS/Library/Preferences/SystemConfiguration"
cp -v $recDir/killall "/Volumes/BS/usr/bin"
cp -rv $recDir/ASinstall/* "/Volumes/BS/System/Library"
cp -v $recDir/launchShellCmd.scpt "/Volumes/BS/System/Installation/CDIS"

###### Manage Patches ######

sh "$recDir/unzipPatchesAndInstallKextsHackFolder.sh" "$hackCreating" "$osxinst" "$recDir" "$tmpFileDir" "/Volumes/BS"

###### Manage CDIS apps ######

mv "/Volumes/BS/System/Installation/CDIS/$osName Utilities.app" "$1/$hackCreating/InstallationFiles/$osName Utils.app"
cp -rv $recDir/JustReboot.app "/Volumes/BS/System/Installation/CDIS"

rm -v "$1/$hackCreating/InstallationFiles/$osName Utils.app/Contents/Resources/Utilities.plist"
if [ -d "/Volumes/BS/System/Installation/CDIS/Time Machine System Restore.app" ]; then utilsPlistName="UtilitiesTimeMachineRestoreApp.plist" ; else utilsPlistName="Utilities.plist" ; fi
cp -v $recDir/$utilsPlistName "$1/$hackCreating/InstallationFiles/$osName Utils.app/Contents/Resources/Utilities.plist"

rm -v "/Volumes/BS/System/Installation/CDIS/$osName Installer.app/Contents/Resources/InstallerMenuAdditions.plist"
if [ -f $tmpFileDir/useAppleInstaller.mcpfoption ]; then cp -v $tmpFileDir/useAppleInstaller.mcpfoption "/Volumes/BS" ; fi

###### Copy MCPF CDIS apps ######

cp -rv $recDir/NewInstall/ExpInstaller.app "/Volumes/BS/System/Installation/CDIS"
cp -rv "$recDir/$osName Utilities.app" "/Volumes/BS/System/Installation/CDIS"
cp -rv $recDir/Reinstall.app "/Volumes/BS/System/Installation/CDIS"

mkdir "$bigTmpStorage/MCPF_Utils_extract"
$recDir/unzip "$1/$hackCreating/Features/MCPF_Utils.zip" -d "$bigTmpStorage/MCPF_Utils_extract"
rm -v "$bigTmpStorage/MCPF_Utils_extract/MacPostFactor Utilities.app/Contents/Resources/OldDUHackElCap.zip"
cp -rv "$bigTmpStorage/MCPF_Utils_extract/MacPostFactor Utilities.app" "/Volumes/BS/System/Installation/CDIS"
rm -rv "$bigTmpStorage/MCPF_Utils_extract"

cp -v $recDir/osascript "/Volumes/BS/System/Installation/CDIS"
cp -v $recDir/killall "/Volumes/BS/System/Installation/CDIS"
cp -v $recDir/RemountVols.scpt "/Volumes/BS/System/Installation/CDIS"
cp -v $recDir/check.sh "/Volumes/BS/System/Installation/CDIS"

###### Yosemite+ Installation Patches ######

if [ "$osxinst" != "ml" ] && [ "$osxinst" != "mav" ]; then
	
	if [ "$osxinst" == "yos" ]; then
		diskmanagementdPath="/Volumes/BS/usr/sbin/diskmanagementd"
	else
		diskmanagementdPath="/Volumes/BS/usr/libexec/diskmanagementd"
	fi

	cp -rv $recDir/NewInstall/OSInstall.framework "/Volumes/BS/System/Library/PrivateFrameworks/Install.framework/Frameworks"
	ln -s ../../Frameworks "/Volumes/BS/System/Library/PrivateFrameworks/Install.framework/Versions/A"
	rm -rv "/Volumes/BS/System/Library/PrivateFrameworks/SystemMigration.framework"
	cp -rv $recDir/NewInstall/SystemMigration.framework "/Volumes/BS/System/Library/PrivateFrameworks"
	rm -v "/Volumes/BS/usr/sbin/installer"
	cp -v $recDir/NewInstall/installer "/Volumes/BS/usr/sbin"
	if [ "$osxinst" == "yos" ]; then
		rm -rv "/Volumes/BS/System/Library/PrivateFrameworks/DiskManagement.framework"
		cp -rv $recDir/NewInstall/dmtest_needs/DiskManagement.framework "/Volumes/BS/System/Library/PrivateFrameworks"
		rm -v "$diskmanagementdPath"
		cp -v $recDir/NewInstall/dmtest_needs/diskmanagementd "$diskmanagementdPath"
	fi

	cp -rv $recDir/NewInstall/AppleShareClientCore.framework "/Volumes/BS/System/Library/Frameworks"

	if [ "$osxinst" != "yos" ]; then
		rm -rv "/Volumes/BS/System/Library/PrivateFrameworks/PackageKit.framework"
		cp -rv $recDir/NewInstall/EC/PackageKit.framework "/Volumes/BS/System/Library/PrivateFrameworks"
	fi
fi

###### Manage boot files ######

rm -v "/Volumes/BS/System/Library/CoreServices/PlatformSupport.plist"
chflags nouchg "/Volumes/BS/System/Library/CoreServices/boot.efi"
rm -v "/Volumes/BS/System/Library/CoreServices/boot.efi"

if [ "$osxinst" == "ml" -o "$osxinst" == "mav" -o "$osxinst" == "yos" ]; then
	boot_efi_folder="ml_mav_yos"
else
	boot_efi_folder="ec_sierra"
fi

if [ "$sys" == "installed" ]; then
	if [ -f /tmp/64efi.mcpfoption ]; then
		cp -v /tmp/rMCPF/hacking_datas/boot_efi/$boot_efi_folder/boot64.efi "/Volumes/BS/System/Library/CoreServices/boot.efi"
	else
		cp -v /tmp/rMCPF/hacking_datas/boot_efi/$boot_efi_folder/boot32.efi "/Volumes/BS/System/Library/CoreServices/boot.efi"
	fi
else
	cp -v /usr/standalone/i386/boot.efi "/Volumes/BS/System/Library/CoreServices"
fi

rm -v "/Volumes/BS/usr/standalone/i386/boot.efi"
cp -v "/Volumes/BS/System/Library/CoreServices/boot.efi" "/Volumes/BS/usr/standalone/i386"
if [ -f "/Volumes/BS/System/Library/CoreServices/bootbase.efi" ]; then
	rm -v "/Volumes/BS/System/Library/CoreServices/bootbase.efi"
	cp -v "/Volumes/BS/System/Library/CoreServices/boot.efi" "/Volumes/BS/System/Library/CoreServices/bootbase.efi"
fi

if [ "$osxinst" == "yos" -o "$osxinst" == "ec" ]; then defaultsWithSLcompatibility "/Volumes/BS/Library/Preferences/SystemConfiguration/com.apple.Boot.plist" "Kernel Flags" -string "kext-dev-mode=1"; fi

###### Hide some files - Sample by Apple (but yet modified) ######

file_list=(swap
	volD
	Hack
	*.inst
	*.mcpf
	*.mcpfoption
);

for file in "${file_list[@]}"; do
	nbFile=$(find /Volumes/BS/* -name "$file" ''-maxdepth 1'' | wc -l)
	if (( $nbFile >= 1 )); then chflags -h hidden /Volumes/BS/$file ; fi
done

###### Creating HackBkp.tar ######

if [ ! -f "/Volumes/BS/smallRecovery.mcpfoption" ]; then
	oldPWD=$pwd
	cd "$1/"
	tar -zcf /Volumes/BS/HackBkp.tar ./$hackCreating
	cd "$oldPWD"
fi

###### Get the kernelcache ######

chmod -R 755 "/Volumes/BS/System/Library/Extensions"
chown -R root:wheel "/Volumes/BS/System/Library/Extensions"
touch "/Volumes/BS/System/Library/Extensions"

if [ "$sys" == "installation" ]; then
	mlKernelPath="$1/mach_kernel"
	otherKernelPath="$1/System/Library/Kernels/kernel"
	if [ -f $tmpFileDir/ml.inst ]; then kern="$mlKernelPath" ; else kern="$otherKernelPath" ; fi
	kextcache -prelinked-kernel $bigTmpStorage/kernelcache -z -K "$kern" -volume-root "/Volumes/BS" "/Volumes/BS/System/Library/Extensions"
	if [ -f $bigTmpStorage/kernelcache ]; then chmod 644 $bigTmpStorage/kernelcache ; fi
else
	if [ -f /Volumes/BS/System/Library/Caches/com.apple.kext.caches/Startup/kernelcache ]; then kcache="/Volumes/BS/System/Library/Caches/com.apple.kext.caches/Startup/kernelcache" ; else kcache="/Volumes/BS/System/Library/PrelinkedKernels/prelinkedkernel" ; fi
	cp -v "$kcache" $tmpFileDir/origKernelCache
fi

#if [ "$sys" == "installed" ]; then
#	if [ ! -f /tmp/kernelcache ]; then
#		if [ -f /Volumes/BS/System/Library/Caches/com.apple.kext.caches/Startup/kernelcache ]; then
#			cp -v /Volumes/BS/System/Library/Caches/com.apple.kext.caches/Startup/kernelcache /tmp/
#		elif [ -f /Volumes/BS/System/Library/PrelinkedKernels/prelinkedkernel ]; then
#			cp -v /Volumes/BS/System/Library/PrelinkedKernels/prelinkedkernel /tmp/kernelcache
#		else
#			echo "Cannot find the kernelcache file to copy to /tmp/"
#		fi
#	fi
#	if [ -f /tmp/kernelcache ]; then chmod 644 /tmp/kernelcache ; fi
#fi

#else
#	if [ -f /smallRecovery.mcpfoption ]; then
#		if [ -f /System/Library/Caches/com.apple.kext.caches/kernelcache ]; then kcache="/System/Library/Caches/com.apple.kext.caches/Startup/kernelcache" ; else kcache="/System/Library/PrelinkedKernels/prelinkedkernel" ; fi
#		cp -v "$kcache" /tmp/kernelcache
#	fi
#fi
