#!/bin/sh

# unzipPatchesAndInstallKextsHackFolder.sh
# Copyrights (c) 2017 @MLforAll. All rights reserved.

# Requires 4 args : hack_folder_name ; osxinst ; rec_dir ; tmp_dir ; dest_path

if [ "$1" == "" ] && [ "$2" == "" ] && [ "$2" == "" ] && [ "$3" == "" ] && [ "$4" == "" ] && [ "$5" == "" ]; then
	echo "This script requires 5 arguments!"
	exit 1
elif [ "$1" == "" -o "$2" == "" -o "$3" == "" -o "$4" == "" -o "$5" == "" ]; then
	echo "Expected 5 arguments but a fewer number was supplied!"
	exit 1
else
	hack_folder_name="$1"
	osxinst="$2"
	rec_dir="$3"
	tmp_dir="$4"
	dest_path="$5"
fi

if [ "$osxinst" == "ec" -o "$osxinst" == "sierra" ]; then
	$rec_dir/unzip "$downloadsFolderPath/USBHostBTPatch.zip" -d "$1/$hack_folder_name/Patches"
	if [ -d "$1/$hack_folder_name/Patches/__MACOSX" ]; then rm -R "$1/$hack_folder_name/Patches/__MACOSX" ; fi
	"$1/$hack_folder_name/Patches/USBHostBTPatch/install.sh" "$1"
fi

if [ ! -f $tmp_dir/instWithoutGFXkexts.mcpfoption ]; then

	if [ -f /tmp/gmaMac.mcpfoption ]; then
		if [ -f /tmp/32install.mcpfoption ]; then
			gfxKextsPatchName="GMA32Kexts"
		else
			gfxKextsPatchName="GMA64Kexts"
		fi
	else
		gfxKextsPatchName="ATINVIDIAGraphicsKexts"
	fi

	$rec_dir/unzip "$downloadsFolderPath/$gfxKextsPatchName.zip" -d "$1/$hack_folder_name/Patches/Graphics/GraphicsDatas"
	if [ -d "$1/$hack_folder_name/Patches/Graphics/GraphicsDatas/__MACOSX" ]; then rm -R "$1/$hack_folder_name/Patches/Graphics/GraphicsDatas/__MACOSX" ; fi

	rm -rv "$dest_path/System/Library/Extensions"/AMD* "$dest_path/System/Library/Extensions"/ATI* "$dest_path/System/Library/Extensions"/NV* "$dest_path/System/Library/Extensions"/GeForce* "$dest_path/System/Library/Extensions"/AppleIntelGMA* "$dest_path/System/Library/Extensions"/*GLDriver.bundle
	cp -rv "$1/$hack_folder_name/Patches/Graphics/GraphicsDatas/$gfxKextsPatchName/"* "$dest_path/System/Library/Extensions"

else
	cp -v $tmp_dir/instWithoutGFXkexts.mcpfoption "$dest_path" ; fi
fi

if [ ! -f $tmp_dir/instWithoutGFXexploit.mcpfoption ]; then

	if [ "$isGMA" == "yes" ]; then
		gfxHackPatchType="GMA"
	else
		gfxHackPatchType="MOF"
	fi
	gfxHackPatchName="GFX_$gfxHackPatchName_$(echo $osxinst | tr 'a-z' 'A-Z')"

	$rec_dir/unzip "$downloadsFolderPath/$gfxHackPatchName.zip" -d "$1/$hack_folder_name/Patches/Graphics/GraphicsDatas"
	if [ -d "$1/$hack_folder_name/Patches/Graphics/GraphicsDatas/__MACOSX" ]; then rm -R "$1/$hack_folder_name/Patches/Graphics/GraphicsDatas/__MACOSX" ; fi

else
	cp -v $tmp_dir/instWithoutGFXexploit.mcpfoption "$dest_path"
fi

if [ -f $tmp_dir/32install.mcpfoption ] && [ "$isGMA" == "yes" ]; then
	cp -v $tmp_dir/32install.mcpfoption "$dest_path"
	if [ "$sys" == "installed" ] && [ ! -f "$1/$hack_folder_name/32install.mcpfoption" ]; then
		$rec_dir/unzip "$downloadsFolderPath/32install.zip" -d "$1/$hack_folder_name/Patches"
		if [ -d "$1/$hack_folder_name/Patches/__MACOSX" ]; then rm -R "$1/$hack_folder_name/Patches/__MACOSX" ; fi
		cp -v $tmp_dir/32install.mcpfoption "$1/$hack_folder_name"
	fi
fi
